// ctempView.cpp : implementation of the CCtempView class
//

#include "stdafx.h"
#include "ctemp.h"

#include "ctempDoc.h"
#include "ctempView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCtempView

IMPLEMENT_DYNCREATE(CCtempView, CFormView)

BEGIN_MESSAGE_MAP(CCtempView, CFormView)
	//{{AFX_MSG_MAP(CCtempView)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCtempView construction/destruction

CCtempView::CCtempView()
	: CFormView(CCtempView::IDD)
{
	//{{AFX_DATA_INIT(CCtempView)
	m_volts = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	busy=FALSE;

}

CCtempView::~CCtempView()
{
}

void CCtempView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCtempView)
	DDX_Text(pDX, IDC_VOLTAGE, m_volts);
	//}}AFX_DATA_MAP
}

BOOL CCtempView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CCtempView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
	CRect r(0,0,0,0);
// Create GP3 object, connect it on port 7 and turn LED on
	m_io.Create(NULL,0,r,this,32000);
	m_io.SetCommPort(7);
	m_io.SetPortopen(TRUE);
	m_io.SetLed(TRUE);
// Start timer
	this->SetTimer(1,500,NULL);

}

/////////////////////////////////////////////////////////////////////////////
// CCtempView diagnostics

#ifdef _DEBUG
void CCtempView::AssertValid() const
{
	CFormView::AssertValid();
}

void CCtempView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CCtempDoc* CCtempView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCtempDoc)));
	return (CCtempDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCtempView message handlers

void CCtempView::OnButton1() 
{
  static BOOL toggle=TRUE;
  while (busy);
  busy=TRUE;
  toggle=!toggle;
  m_io.SetLed(toggle);
  busy=FALSE;
}

void CCtempView::OnTimer(UINT nIDEvent) 
{
    
    if (nIDEvent==1 && ! busy) 
	{
		busy=TRUE;
		double v=5.0*m_io.a2d(0)/1023;
		m_volts.Format("%2.2lf V",v);
		this->UpdateData(FALSE);
		busy=FALSE;

	}
	CFormView::OnTimer(nIDEvent);
}

void CCtempView::OnDestroy() 
{
	m_io.SetPortopen(FALSE);
	CFormView::OnDestroy();
	
    	
}

